<?php
/*
 * PAYPAL SUBSCRIPTION MANAGER
 *
 * @package PaypalSubscriptionManager
 * @author  Michael J. Pawlowsky <mikep@mi-software.com>
 * @copyright Copyright &copy; 2005, Ultimate Internet Marketing
 * @version $Id: Config.class.php,v 1.2 2005/09/07 21:14:13 mikep Exp $;
 *
 * Created: Wed Sep 07 07:02:00 EDT 2005 07:02:00
 * Last Modified: $Date: 2005/09/07 21:14:13 $
 * Revision: $Rev:$
 *
 */

class Config{

	var $include_path = '';

	var $db_host = 'localhost';
	var $db_user = 'db_user';
	var $db_pw   = 'db_pw';
	var $db_name = 'memberdb';

	var $site_doc_root = '';
	var $site_url_root = '';

	var $site_name   = 'My Subscription Site';
	var $site_url    = 'http://www.mydomain.com/';
	var $site_domain = 'mydomain.com';
	var $site_email  = 'webmaster@mydomain.com';

	var $paypal_account = 'sales@mydomain.com';
	var $paypal_url = 'https://www.paypal.com/cgi-bin/webscr';
    var $paypal_return_url = '';
	var $paypal_cancel_url = '';

	var $period1_active = 0;
	var $period1_value = 7;
	var $period1_interval = 'D';
	var $amount1  = '9.95';

	var $period2_active = 0;
	var $period2_value = 14;
	var $period2_interval = 'D';
	var $amount2  = '19.95';

	var $period3_value = 1;
	var $period3_interval = 'M';
	var $amount3  = '29.95';

	var $paypal_icon = 'https://www.paypalobjects.com/en_US/i/btn/x-click-but20.gif';

	var $autorespond_active = 0;
	var $autorespond_to = 'mysite@automatic-responder.com';
	var $autorespond_subject = 'Membership Signup';
	var $autorespond_body = 'Please subscribe me, I just joined your membership site.';

	var $err_no  = 0;
	var $err_msg = '';




	function Config($setdef = 0){

		$dir     = getcwd();
		$pos     = strpos($dir, "/install");
		$docdir  = substr($dir, 0, $pos);
		$rootlen = strlen($_SERVER['DOCUMENT_ROOT']);
		$htpath  = substr($docdir, $rootlen);

		if($setdef){
			// Set defaults

			$this->site_doc_root = $docdir;
			$this->site_url_root = $htpath;

			echo $htpath;

			$this->site_url          = 'http://' . $_SERVER['HTTP_HOST'] . $htpath;
			$this->paypal_return_url = 'http://' . $_SERVER['HTTP_HOST'] . $htpath . '/thanks.html';
			$this->paypal_cancel_url = 'http://' . $_SERVER['HTTP_HOST'] . $htpath . '/cancel.html';

			// find the domain name. Will not work for all hostnames but will give a good start.
			$matches = array();
			if(preg_match("/[a-z0-9-]*.[a-z]*$/", $_SERVER['HTTP_HOST'], $matches)){
				$domain = $matches[0];
			} else {
				$domain = "domain.com";
			}
			$this->site_domain = $domain;
			$this->site_email = 'webmaster@' . $domain;
			$this->paypal_account = 'sales@' . $domain;
		}

		$this->include_path = ini_get('include_path') . ':' . $docdir . '/lib';
	}


	function writeConfig($template=''){
		$config_file = fopen('../lib/config.php', 'w', false);
		if(!$config_file){
			$this->err_no = -1;
			$this->err_msg = 'Unable to open config file for writing';
			return ($this->err_no);
		}
		if(!fwrite($config_file, $template)){
			$this->err_no = -2;
			$this->err_msg = 'Unable to write template to config file';
			return ($this->err_no);
		}
		@fflush($config_file);
		if(!fclose($config_file)){
			$this->err_no = -3;
			$this->err_msg = 'Unable to close config file';
			return ($this->err_no);
		}
		return ($this->err_no);
	}


	function readConfig($path = ''){

		if($path == ''){
			$path = '../lib/config.php';
		}

		$config_file = fopen($path, 'r', false);
		if(!$config_file){
			$this->err_no = -1;
			$this->err_msg = 'Unable to open config file for reading';
			return ($this->err_no);
		}

		// Place to store values.
		$vals = array();

		while(!feof($config_file)){
			$line = fgets($config_file);

			if(preg_match("/define\('([a-zA-Z0-9-_]*)', *'(.*)'\);/i", $line, $vals)){
				switch ($vals[1]){

					case 'SITE_NAME':
						$this->site_name = $vals[2];
					break;

					case 'SITE_DOMAIN':
						$this->site_domain = $vals[2];
					break;

					case 'SITE_URL':
						$this->site_url = $vals[2];
					break;

					case 'SITE_DOC_ROOT':
						$this->site_doc_root = $vals[2];
					break;

					case 'SITE_URL_ROOT':
						$this->site_url_root = $vals[2];
					break;

					case 'WEBMASTER_EMAIL':
						$this->site_email = $vals[2];
					break;

					case 'DB_HOST':
						$this->db_host = $vals[2];
					break;

					case 'DB_NAME':
						$this->db_name = $vals[2];
					break;

					case 'DB_USER':
						$this->db_user = $vals[2];
					break;

					case 'DB_PASSWORD':
						$this->db_pw = $vals[2];
					break;

					case 'PAYPAL_ACCOUNT':
						$this->paypal_account = $vals[2];
					break;

					case 'PAYPAL_URL':
						$this->paypal_url = $vals[2];
					break;

					case 'PAYPAL_RETURN_URL':
						$this->paypal_return_url = $vals[2];
					break;

					case 'PAYPAL_CANCEL_URL':
						$this->paypal_cancel_url = $vals[2];
					break;

					case 'PERIOD1_ACTIVE':
						$this->period1_active = $vals[2];
					break;

					case 'PERIOD1_VALUE':
						$this->period1_value = $vals[2];
					break;

					case 'PERIOD1_INTERVAL':
						$this->period1_interval = $vals[2];
					break;

					case 'AMOUNT1':
						$this->amount1 = $vals[2];
					break;

					case 'PERIOD2_ACTIVE':
						$this->period2_active = $vals[2];
					break;

					case 'PERIOD2_VALUE':
						$this->period2_value = $vals[2];
					break;

					case 'PERIOD2_INTERVAL':
						$this->period2_interval = $vals[2];
					break;

					case 'AMOUNT2':
						$this->amount2 = $vals[2];
					break;

					case 'PERIOD3_VALUE':
						$this->period3_value = $vals[2];
					break;

					case 'PERIOD3_INTERVAL':
						$this->period3_interval = $vals[2];
					break;

					case 'AMOUNT3':
						$this->amount3 = $vals[2];
					break;

					case 'PAYPAL_ICON':
						$this->paypal_icon = $vals[2];
					break;

					case 'AUTORESPOND_ACTIVE':
						$this->autorespond_active = $vals[2];
					break;

					case 'AUTORESPOND_TO':
						$this->autorespond_to = $vals[2];
					break;

					case 'AUTORESPOND_SUBJECT':
						$this->autorespond_subject = $vals[2];
					break;

					case 'AUTORESPOND_BODY':
						$this->autorespond_body = $vals[2];
					break;

					default:
					break;

				}
			}
		}

		if(!fclose($config_file)){
			$this->err_no = -3;
			$this->err_msg = 'Unable to close config file';
			return ($this->err_no);
		}
		return ($this->err_no);
	}



    function writeHtaccess(){
		$ht = fopen('../members/.htaccess', 'w', false);
		if(!$ht){
			$this->err_no = -1;
			$this->err_msg = 'Unable to open htaccess file for writing';
			return ($this->err_no);
		}

		$txt = 'AuthUserFile ' . $this->site_doc_root. '/members/.htpasswd' . chr(10)
		     . 'AuthType Basic' . chr(10)
		     . 'AuthName "' . $this->site_name . '"' . chr(10)
		     . 'require valid-user' . chr(10);

		if(!fwrite($ht, $txt)){
			$this->err_no = -2;
			$this->err_msg = 'Unable to write htaccess file';
			return ($this->err_no);
		}
		@fflush($ht);
		if(!fclose($ht)){
			$this->err_no = -3;
			$this->err_msg = 'Unable to close htaccess file';
			return ($this->err_no);
		}
		return ($this->err_no);
	}


    function writeManagerHtaccess(){
		$ht = fopen('../manager/.htaccess', 'w', false);
		if(!$ht){
			$this->err_no = -1;
			$this->err_msg = 'Unable to open htaccess file for writing';
			return ($this->err_no);
		}

		$txt = 'AuthUserFile ' . $this->site_doc_root. '/manager/.htpasswd' . chr(10)
		     . 'AuthType Basic' . chr(10)
		     . 'AuthName "' . $this->site_name . ' - Manager"' . chr(10)
		     . 'require valid-user' . chr(10);

		if(!fwrite($ht, $txt)){
			$this->err_no = -2;
			$this->err_msg = 'Unable to write htaccess file';
			return ($this->err_no);
		}
		@fflush($ht);
		if(!fclose($ht)){
			$this->err_no = -3;
			$this->err_msg = 'Unable to close htaccess file';
			return ($this->err_no);
		}
		return ($this->err_no);
	}


}

?>