<?php

/*
 * PAYPAL SUBSCRIPTION MANAGER
 *
 * @package PaypalSubscriptionManager
 * @author  Michael J. Pawlowsky <mikep@mi-software.com>
 * @copyright Copyright &copy; 2005, Ultimate Internet Marketing
 * @version $Id: Install.class.php,v 1.2 2005/09/07 21:14:25 mikep Exp $;
 *
 * Created: Wed Sep 07 07:02:00 EDT 2005 07:02:00
 * Last Modified: $Date: 2005/09/07 21:14:25 $
 * Revision: $Rev:$
 *
 */

require_once('Db.class.php');


class Install{

	var $config_writable = 0;
	var $htaccess_writable = 0;
	var $htpasswd_writable = 0;
	var $templates_c_writable = 0;
	var $err_msg = '';
	var $err_no = 0;

	function Install(){

	}


	function checkPerms(){

		// Check to see if we can write to the config file.
		$config_file = @fopen('../lib/config.php', 'a', false);
		if($config_file){
			$this->config_writable = 1;
			fclose($config_file);
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to config file. "
			               . "Please set the permissions to /lib/config.php so the web server "
			               . "can write to it, either by setting the file permissions to 0666 or "
			               . " changing the owner of the file to the same user as the web server "
			               . " is running as.</p>";
		}


		// Check to see if we can write to the .htaccess.
		$htaccess_file = @fopen('../members/.htaccess', 'a', false);
		if($htaccess_file){
			$this->htaccess_writable = 1;
			fclose($htaccess_file);
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to htaccess file. "
			               . "Please set the permissions to /members/.htaccess so the web server "
			               . "can write to it, either by setting the file permissions to 0666 or "
			               . " changing the owner of the file to the same user as the web server "
			               . " is running as.</p>";
		}

		// Check to see if we can write to the .htpasswd.
		$htpasswd_file = @fopen('../members/.htpasswd', 'a', false);
		if($htpasswd_file){
			$this->htpasswd_writable = 1;
			fclose($htpasswd_file);
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to htpasswd file. "
			               . "Please set the permissions to /members/.htpasswd so the web server "
			               . "can write to it, either by setting the file permissions to 0666 or "
			               . " changing the owner of the file to the same user as the web server "
			               . " is running as.</p>";
		}


		// Check to see if we can write to the manager/.htaccess.
		$htaccess_file = @fopen('../manager/.htaccess', 'a', false);
		if($htaccess_file){
			$this->htaccess_writable = 1;
			fclose($htaccess_file);
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to htaccess file. "
			               . "Please set the permissions to /manager/.htaccess so the web server "
			               . "can write to it, either by setting the file permissions to 0666 or "
			               . " changing the owner of the file to the same user as the web server "
			               . " is running as.</p>";
		}


		// Check to see if we can write to the .htpasswd.
		$htpasswd_file = @fopen('../manager/.htpasswd', 'a', false);
		if($htpasswd_file){
			$this->htpasswd_writable = 1;
			fclose($htpasswd_file);
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to htpasswd file. "
			               . "Please set the permissions to /manager/.htpasswd so the web server "
			               . "can write to it, either by setting the file permissions to 0666 or "
			               . " changing the owner of the file to the same user as the web server "
			               . " is running as.</p>";
		}


		// Make sure smarty can write to the template directories.
		$test_file = @fopen('../templates_c/test.txt', 'a', false);
		if($test_file){
			$this->templates_c_writable = 1;
			unlink('../templates_c/test.txt');
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to /templates_c directory. "
			               . "Please set the permissions to /templates_c so the web server "
			               . "can write to it, either by making the permissions 0777 or "
			               . " changing the owner of the directoty to the same user as the web server "
			               . " is running as.</p>";
		}

		// Make sure smarty can write to the template directories.
		$test_file = @fopen('../manager/templates_c/test.txt', 'a', false);
		if($test_file){
			$this->templates_c_writable = 1;
			unlink('../manager/templates_c/test.txt');
		} else {
			$this->err_no++;
			$this->err_msg .= "<p>Unable to write to /manager/templates_c directory. "
			               . "Please set the permissions to /manager/templates_c so the web server "
			               . "can write to it, either by making the permissions 0777 or "
			               . " changing the owner of the directoty to the same user as the web server "
			               . " is running as.</p>";
		}


	}


	function createTables($db_host, $db_name, $db_user,  $db_pw){
		$sql = new MySQL_class();
		$sql->Setup($db_user, $db_pw, $db_host);

		$sql->Create($db_name);
		if($sql->err_no != 0){
			$this->err_no = $sql->err_no;
			$this->err_msg = $sql->err_msg;
			return($this->err_no);
		}

		$qry = array();

		$qry[] = "DROP TABLE IF EXISTS `tblCountries`";
		$qry[] = "CREATE TABLE `tblCountries` (
		  `countries_id` int(11) NOT NULL auto_increment,
		  `countries_name` varchar(64) NOT NULL default '',
		  `countries_iso_code_2` varchar(2) NOT NULL default '',
		  `countries_iso_code_3` varchar(3) NOT NULL default '',
		  `address_format_id` int(11) NOT NULL default '0',
		  PRIMARY KEY  (`countries_id`),
		  UNIQUE KEY `IDX_UNIQUE_COUNTRIES_ISO_CODE_2` (`countries_iso_code_2`),
		  KEY `IDX_COUNTRIES_NAME` (`countries_name`)
		);";

		$qry[] = "INSERT INTO `tblCountries` VALUES (1, 'Afghanistan', 'AF', 'AFG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (2, 'Albania', 'AL', 'ALB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (3, 'Algeria', 'DZ', 'DZA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (4, 'American Samoa', 'AS', 'ASM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (5, 'Andorra', 'AD', 'AND', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (6, 'Angola', 'AO', 'AGO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (7, 'Anguilla', 'AI', 'AIA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (8, 'Antarctica', 'AQ', 'ATA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (9, 'Antigua and Barbuda', 'AG', 'ATG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (10, 'Argentina', 'AR', 'ARG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (11, 'Armenia', 'AM', 'ARM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (12, 'Aruba', 'AW', 'ABW', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (13, 'Australia', 'AU', 'AUS', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (14, 'Austria', 'AT', 'AUT', 5);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (15, 'Azerbaijan', 'AZ', 'AZE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (16, 'Bahamas', 'BS', 'BHS', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (17, 'Bahrain', 'BH', 'BHR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (18, 'Bangladesh', 'BD', 'BGD', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (19, 'Barbados', 'BB', 'BRB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (20, 'Belarus', 'BY', 'BLR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (21, 'Belgium', 'BE', 'BEL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (22, 'Belize', 'BZ', 'BLZ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (23, 'Benin', 'BJ', 'BEN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (24, 'Bermuda', 'BM', 'BMU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (25, 'Bhutan', 'BT', 'BTN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (26, 'Bolivia', 'BO', 'BOL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (27, 'Bosnia and Herzegowina', 'BA', 'BIH', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (28, 'Botswana', 'BW', 'BWA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (29, 'Bouvet Island', 'BV', 'BVT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (30, 'Brazil', 'BR', 'BRA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (31, 'British Indian Ocean Territory', 'IO', 'IOT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (32, 'Brunei Darussalam', 'BN', 'BRN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (33, 'Bulgaria', 'BG', 'BGR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (34, 'Burkina Faso', 'BF', 'BFA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (35, 'Burundi', 'BI', 'BDI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (36, 'Cambodia', 'KH', 'KHM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (37, 'Cameroon', 'CM', 'CMR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (38, 'Canada', 'CA', 'CAN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (39, 'Cape Verde', 'CV', 'CPV', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (40, 'Cayman Islands', 'KY', 'CYM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (41, 'Central African Republic', 'CF', 'CAF', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (42, 'Chad', 'TD', 'TCD', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (43, 'Chile', 'CL', 'CHL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (44, 'China', 'CN', 'CHN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (45, 'Christmas Island', 'CX', 'CXR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (46, 'Cocos (Keeling) Islands', 'CC', 'CCK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (47, 'Colombia', 'CO', 'COL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (48, 'Comoros', 'KM', 'COM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (49, 'Congo', 'CG', 'COG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (50, 'Cook Islands', 'CK', 'COK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (51, 'Costa Rica', 'CR', 'CRI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (52, 'Cote D''Ivoire', 'CI', 'CIV', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (53, 'Croatia', 'HR', 'HRV', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (54, 'Cuba', 'CU', 'CUB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (55, 'Cyprus', 'CY', 'CYP', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (56, 'Czech Republic', 'CZ', 'CZE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (57, 'Denmark', 'DK', 'DNK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (58, 'Djibouti', 'DJ', 'DJI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (59, 'Dominica', 'DM', 'DMA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (60, 'Dominican Republic', 'DO', 'DOM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (61, 'East Timor', 'TP', 'TMP', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (62, 'Ecuador', 'EC', 'ECU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (63, 'Egypt', 'EG', 'EGY', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (64, 'El Salvador', 'SV', 'SLV', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (65, 'Equatorial Guinea', 'GQ', 'GNQ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (66, 'Eritrea', 'ER', 'ERI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (67, 'Estonia', 'EE', 'EST', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (68, 'Ethiopia', 'ET', 'ETH', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (70, 'Faroe Islands', 'FO', 'FRO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (71, 'Fiji', 'FJ', 'FJI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (72, 'Finland', 'FI', 'FIN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (73, 'France', 'FR', 'FRA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (74, 'France, Metropolitan', 'FX', 'FXX', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (75, 'French Guiana', 'GF', 'GUF', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (76, 'French Polynesia', 'PF', 'PYF', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (77, 'French Southern Territories', 'TF', 'ATF', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (78, 'Gabon', 'GA', 'GAB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (79, 'Gambia', 'GM', 'GMB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (80, 'Georgia', 'GE', 'GEO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (81, 'Germany', 'DE', 'DEU', 5);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (82, 'Ghana', 'GH', 'GHA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (83, 'Gibraltar', 'GI', 'GIB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (84, 'Greece', 'GR', 'GRC', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (85, 'Greenland', 'GL', 'GRL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (86, 'Grenada', 'GD', 'GRD', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (87, 'Guadeloupe', 'GP', 'GLP', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (88, 'Guam', 'GU', 'GUM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (89, 'Guatemala', 'GT', 'GTM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (90, 'Guinea', 'GN', 'GIN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (91, 'Guinea-bissau', 'GW', 'GNB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (92, 'Guyana', 'GY', 'GUY', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (93, 'Haiti', 'HT', 'HTI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (94, 'Heard and Mc Donald Islands', 'HM', 'HMD', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (95, 'Honduras', 'HN', 'HND', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (96, 'Hong Kong', 'HK', 'HKG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (97, 'Hungary', 'HU', 'HUN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (98, 'Iceland', 'IS', 'ISL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (99, 'India', 'IN', 'IND', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (100, 'Indonesia', 'ID', 'IDN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (101, 'Iran (Islamic Republic of)', 'IR', 'IRN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (102, 'Iraq', 'IQ', 'IRQ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (103, 'Ireland', 'IE', 'IRL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (104, 'Israel', 'IL', 'ISR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (105, 'Italy', 'IT', 'ITA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (106, 'Jamaica', 'JM', 'JAM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (107, 'Japan', 'JP', 'JPN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (108, 'Jordan', 'JO', 'JOR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (109, 'Kazakhstan', 'KZ', 'KAZ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (110, 'Kenya', 'KE', 'KEN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (111, 'Kiribati', 'KI', 'KIR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (112, 'Korea, Democratic People''s Republic of', 'KP', 'PRK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (113, 'Korea, Republic of', 'KR', 'KOR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (114, 'Kuwait', 'KW', 'KWT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (115, 'Kyrgyzstan', 'KG', 'KGZ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (116, 'Lao People''s Democratic Republic', 'LA', 'LAO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (117, 'Latvia', 'LV', 'LVA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (118, 'Lebanon', 'LB', 'LBN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (119, 'Lesotho', 'LS', 'LSO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (120, 'Liberia', 'LR', 'LBR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (122, 'Liechtenstein', 'LI', 'LIE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (123, 'Lithuania', 'LT', 'LTU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (124, 'Luxembourg', 'LU', 'LUX', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (125, 'Macau', 'MO', 'MAC', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (127, 'Madagascar', 'MG', 'MDG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (128, 'Malawi', 'MW', 'MWI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (129, 'Malaysia', 'MY', 'MYS', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (130, 'Maldives', 'MV', 'MDV', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (131, 'Mali', 'ML', 'MLI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (132, 'Malta', 'MT', 'MLT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (133, 'Marshall Islands', 'MH', 'MHL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (134, 'Martinique', 'MQ', 'MTQ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (135, 'Mauritania', 'MR', 'MRT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (136, 'Mauritius', 'MU', 'MUS', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (137, 'Mayotte', 'YT', 'MYT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (138, 'Mexico', 'MX', 'MEX', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (139, 'Micronesia, Federated States of', 'FM', 'FSM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (140, 'Moldova, Republic of', 'MD', 'MDA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (141, 'Monaco', 'MC', 'MCO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (142, 'Mongolia', 'MN', 'MNG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (143, 'Montserrat', 'MS', 'MSR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (144, 'Morocco', 'MA', 'MAR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (145, 'Mozambique', 'MZ', 'MOZ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (146, 'Myanmar', 'MM', 'MMR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (147, 'Namibia', 'NA', 'NAM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (148, 'Nauru', 'NR', 'NRU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (149, 'Nepal', 'NP', 'NPL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (150, 'Netherlands', 'NL', 'NLD', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (151, 'Netherlands Antilles', 'AN', 'ANT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (152, 'New Caledonia', 'NC', 'NCL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (153, 'New Zealand', 'NZ', 'NZL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (154, 'Nicaragua', 'NI', 'NIC', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (155, 'Niger', 'NE', 'NER', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (156, 'Nigeria', 'NG', 'NGA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (157, 'Niue', 'NU', 'NIU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (158, 'Norfolk Island', 'NF', 'NFK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (159, 'Northern Mariana Islands', 'MP', 'MNP', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (160, 'Norway', 'NO', 'NOR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (161, 'Oman', 'OM', 'OMN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (162, 'Pakistan', 'PK', 'PAK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (163, 'Palau', 'PW', 'PLW', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (164, 'Panama', 'PA', 'PAN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (165, 'Papua New Guinea', 'PG', 'PNG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (166, 'Paraguay', 'PY', 'PRY', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (167, 'Peru', 'PE', 'PER', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (168, 'Philippines', 'PH', 'PHL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (169, 'Pitcairn', 'PN', 'PCN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (170, 'Poland', 'PL', 'POL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (171, 'Portugal', 'PT', 'PRT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (172, 'Puerto Rico', 'PR', 'PRI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (173, 'Qatar', 'QA', 'QAT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (174, 'Reunion', 'RE', 'REU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (175, 'Romania', 'RO', 'ROM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (176, 'Russian Federation', 'RU', 'RUS', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (177, 'Rwanda', 'RW', 'RWA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (178, 'Saint Kitts and Nevis', 'KN', 'KNA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (179, 'Saint Lucia', 'LC', 'LCA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (181, 'Samoa', 'WS', 'WSM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (182, 'San Marino', 'SM', 'SMR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (183, 'Sao Tome and Principe', 'ST', 'STP', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (184, 'Saudi Arabia', 'SA', 'SAU', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (185, 'Senegal', 'SN', 'SEN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (186, 'Seychelles', 'SC', 'SYC', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (187, 'Sierra Leone', 'SL', 'SLE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (188, 'Singapore', 'SG', 'SGP', 4);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (190, 'Slovenia', 'SI', 'SVN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (191, 'Solomon Islands', 'SB', 'SLB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (192, 'Somalia', 'SO', 'SOM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (193, 'South Africa', 'ZA', 'ZAF', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (195, 'Spain', 'ES', 'ESP', 3);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (196, 'Sri Lanka', 'LK', 'LKA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (197, 'St. Helena', 'SH', 'SHN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (198, 'St. Pierre and Miquelon', 'PM', 'SPM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (199, 'Sudan', 'SD', 'SDN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (200, 'Suriname', 'SR', 'SUR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (202, 'Swaziland', 'SZ', 'SWZ', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (203, 'Sweden', 'SE', 'SWE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (204, 'Switzerland', 'CH', 'CHE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (205, 'Syrian Arab Republic', 'SY', 'SYR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (206, 'Taiwan', 'TW', 'TWN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (207, 'Tajikistan', 'TJ', 'TJK', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (208, 'Tanzania, United Republic of', 'TZ', 'TZA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (209, 'Thailand', 'TH', 'THA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (210, 'Togo', 'TG', 'TGO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (211, 'Tokelau', 'TK', 'TKL', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (212, 'Tonga', 'TO', 'TON', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (213, 'Trinidad and Tobago', 'TT', 'TTO', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (214, 'Tunisia', 'TN', 'TUN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (215, 'Turkey', 'TR', 'TUR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (216, 'Turkmenistan', 'TM', 'TKM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (217, 'Turks and Caicos Islands', 'TC', 'TCA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (218, 'Tuvalu', 'TV', 'TUV', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (219, 'Uganda', 'UG', 'UGA', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (220, 'Ukraine', 'UA', 'UKR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (221, 'United Arab Emirates', 'AE', 'ARE', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (222, 'United Kingdom', 'GB', 'GBR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (223, 'United States', 'US', 'USA', 2);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (224, 'United States Minor Outlying Islands', 'UM', 'UMI', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (225, 'Uruguay', 'UY', 'URY', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (226, 'Uzbekistan', 'UZ', 'UZB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (227, 'Vanuatu', 'VU', 'VUT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (228, 'Vatican City State (Holy See)', 'VA', 'VAT', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (229, 'Venezuela', 'VE', 'VEN', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (230, 'Viet Nam', 'VN', 'VNM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (231, 'Virgin Islands (British)', 'VG', 'VGB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (232, 'Virgin Islands (U.S.)', 'VI', 'VIR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (233, 'Wallis and Futuna Islands', 'WF', 'WLF', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (234, 'Western Sahara', 'EH', 'ESH', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (235, 'Yemen', 'YE', 'YEM', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (236, 'Yugoslavia', 'YU', 'YUG', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (237, 'Zaire', 'ZR', 'ZAR', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (238, 'Zambia', 'ZM', 'ZMB', 1);";
		$qry[] = "INSERT INTO `tblCountries` VALUES (239, 'Zimbabwe', 'ZW', 'ZWE', 1);";

		$qry[] = "DROP TABLE IF EXISTS `tblStates`;";
		$qry[] = "CREATE TABLE `tblStates` (
		  `states_id` int(11) NOT NULL auto_increment,
		  `states_name` varchar(40) NOT NULL default '',
		  `states_abbrev` varchar(3) NOT NULL default '',
		  PRIMARY KEY  (`states_id`)
		);";

		$qry[] = "INSERT INTO `tblStates` VALUES (1, 'Alabama', 'AL');";
		$qry[] = "INSERT INTO `tblStates` VALUES (2, 'Alaska', 'AK');";
		$qry[] = "INSERT INTO `tblStates` VALUES (3, 'American Samoa', 'AS');";
		$qry[] = "INSERT INTO `tblStates` VALUES (4, 'Arizona', 'AZ');";
		$qry[] = "INSERT INTO `tblStates` VALUES (5, 'Arkansas', 'AR');";
		$qry[] = "INSERT INTO `tblStates` VALUES (6, 'Armed Forces - Africa/Canada/Europe/ME', 'AE');";
		$qry[] = "INSERT INTO `tblStates` VALUES (7, 'Armed Forces - Pacific', 'AP');";
		$qry[] = "INSERT INTO `tblStates` VALUES (8, 'Armed Forces - Americas', 'AA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (9, 'California', 'CA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (10, 'Colorado', 'CO');";
		$qry[] = "INSERT INTO `tblStates` VALUES (11, 'Connecticut', 'CT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (12, 'Delaware', 'DE');";
		$qry[] = "INSERT INTO `tblStates` VALUES (13, 'District of Columbia', 'DC');";
		$qry[] = "INSERT INTO `tblStates` VALUES (14, 'Federated States of Micronesia', 'FM');";
		$qry[] = "INSERT INTO `tblStates` VALUES (15, 'Florida', 'FL');";
		$qry[] = "INSERT INTO `tblStates` VALUES (16, 'Georgia', 'GA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (17, 'Guam', 'GU');";
		$qry[] = "INSERT INTO `tblStates` VALUES (18, 'Hawaii', 'HI');";
		$qry[] = "INSERT INTO `tblStates` VALUES (19, 'Idaho', 'ID');";
		$qry[] = "INSERT INTO `tblStates` VALUES (20, 'Illinois', 'IL');";
		$qry[] = "INSERT INTO `tblStates` VALUES (21, 'Indiana', 'IN');";
		$qry[] = "INSERT INTO `tblStates` VALUES (22, 'Iowa', 'IA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (23, 'Kansas', 'KS');";
		$qry[] = "INSERT INTO `tblStates` VALUES (24, 'Kentucky', 'KY');";
		$qry[] = "INSERT INTO `tblStates` VALUES (25, 'Louisiana', 'LA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (26, 'Maine', 'ME');";
		$qry[] = "INSERT INTO `tblStates` VALUES (27, 'Marshall Islands', 'MH');";
		$qry[] = "INSERT INTO `tblStates` VALUES (28, 'Maryland', 'MD');";
		$qry[] = "INSERT INTO `tblStates` VALUES (29, 'Massachusetts', 'MA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (30, 'Michigan', 'MI');";
		$qry[] = "INSERT INTO `tblStates` VALUES (31, 'Minnesota', 'MN');";
		$qry[] = "INSERT INTO `tblStates` VALUES (32, 'Mississippi', 'MS');";
		$qry[] = "INSERT INTO `tblStates` VALUES (33, 'Missouri', 'MO');";
		$qry[] = "INSERT INTO `tblStates` VALUES (34, 'Montana', 'MT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (35, 'Nebraska', 'NE');";
		$qry[] = "INSERT INTO `tblStates` VALUES (36, 'Nevada', 'NV');";
		$qry[] = "INSERT INTO `tblStates` VALUES (37, 'New Hampshire', 'NH');";
		$qry[] = "INSERT INTO `tblStates` VALUES (38, 'New Jersey', 'NJ');";
		$qry[] = "INSERT INTO `tblStates` VALUES (39, 'New Mexico', 'NM');";
		$qry[] = "INSERT INTO `tblStates` VALUES (40, 'New York', 'NY');";
		$qry[] = "INSERT INTO `tblStates` VALUES (41, 'North Carolina', 'NC');";
		$qry[] = "INSERT INTO `tblStates` VALUES (42, 'North Dakota', 'ND');";
		$qry[] = "INSERT INTO `tblStates` VALUES (43, 'Ohio', 'OH');";
		$qry[] = "INSERT INTO `tblStates` VALUES (44, 'Oklahoma', 'OK');";
		$qry[] = "INSERT INTO `tblStates` VALUES (45, 'Oregon', 'OR');";
		$qry[] = "INSERT INTO `tblStates` VALUES (46, 'Pennsylvania', 'PA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (47, 'Puerto Rico', 'PR');";
		$qry[] = "INSERT INTO `tblStates` VALUES (48, 'Rhode Island', 'RI');";
		$qry[] = "INSERT INTO `tblStates` VALUES (49, 'South Carolina', 'SC');";
		$qry[] = "INSERT INTO `tblStates` VALUES (50, 'South Dakota', 'SD');";
		$qry[] = "INSERT INTO `tblStates` VALUES (51, 'Tennessee', 'TN');";
		$qry[] = "INSERT INTO `tblStates` VALUES (52, 'Texas', 'TX');";
		$qry[] = "INSERT INTO `tblStates` VALUES (53, 'Utah', 'UT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (54, 'Vermont', 'VT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (55, 'Virgin Islands', 'VI');";
		$qry[] = "INSERT INTO `tblStates` VALUES (56, 'Virginia', 'VA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (57, 'Washington', 'WA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (58, 'West Virginia', 'WV');";
		$qry[] = "INSERT INTO `tblStates` VALUES (59, 'Wisconsin', 'WI');";
		$qry[] = "INSERT INTO `tblStates` VALUES (60, 'Wyoming', 'WY');";
		$qry[] = "INSERT INTO `tblStates` VALUES (61, 'Alberta', 'AB');";
		$qry[] = "INSERT INTO `tblStates` VALUES (62, 'British Columbia', 'BC');";
		$qry[] = "INSERT INTO `tblStates` VALUES (63, 'Manitoba', 'MB');";
		$qry[] = "INSERT INTO `tblStates` VALUES (64, 'New Brunswick', 'NB');";
		$qry[] = "INSERT INTO `tblStates` VALUES (65, 'Newfoundland and Labrador', 'NL');";
		$qry[] = "INSERT INTO `tblStates` VALUES (67, 'Nunavut', 'NU');";
		$qry[] = "INSERT INTO `tblStates` VALUES (68, 'Nova Scotia', 'NS');";
		$qry[] = "INSERT INTO `tblStates` VALUES (69, 'Ontario', 'ON');";
		$qry[] = "INSERT INTO `tblStates` VALUES (71, 'Prince Edward Island', 'PE');";
		$qry[] = "INSERT INTO `tblStates` VALUES (72, 'Quebec', 'QC');";
		$qry[] = "INSERT INTO `tblStates` VALUES (73, 'Saskatchewan', 'SK');";
		$qry[] = "INSERT INTO `tblStates` VALUES (74, 'Yukon Territory', 'YT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (75, 'Australian Capital Territory', 'ACT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (76, 'New South Wales', 'NSW');";
		$qry[] = "INSERT INTO `tblStates` VALUES (77, 'Northern Territory', 'NT');";
		$qry[] = "INSERT INTO `tblStates` VALUES (78, 'Queensland', 'QLD');";
		$qry[] = "INSERT INTO `tblStates` VALUES (79, 'South Australia', 'SA');";
		$qry[] = "INSERT INTO `tblStates` VALUES (80, 'Tasmania', 'TAS');";
		$qry[] = "INSERT INTO `tblStates` VALUES (81, 'Victoria', 'VIC');";
		$qry[] = "INSERT INTO `tblStates` VALUES (82, 'Western Australia', 'WA');";

		$qry[] = "DROP TABLE IF EXISTS `tblTxnLog`;";
		$qry[] = "CREATE TABLE `tblTxnLog` (
		  `log_id` int(11) NOT NULL auto_increment,
		  `user_id` int(11) NOT NULL default '0',
		  `txn_id` varbinary(32) NOT NULL default '',
		  `payer_id` varbinary(32) NOT NULL default '',
		  `subscr_id` varbinary(32) NOT NULL default '',
		  `txn_type` varchar(32) NOT NULL default '',
		  `item_name` varchar(255) NOT NULL default '',
		  `item_number` varchar(64) NOT NULL default '',
		  `mc_gross` float(9,2) NOT NULL default '0.00',
		  `mc_fee` float(9,2) NOT NULL default '0.00',
		  `txn_date` int(11) NOT NULL default '0',
		  PRIMARY KEY  (`log_id`),
		  KEY `user_id` (`user_id`)
		);";

		$qry[] = "DROP TABLE IF EXISTS `tblUserStatus`;";
		$qry[] = "CREATE TABLE `tblUserStatus` (
		  `status_id` int(11) NOT NULL auto_increment,
		  `status_name` varchar(32) NOT NULL default '',
		  PRIMARY KEY  (`status_id`)
		);";

		$qry[] = "INSERT INTO `tblUserStatus` VALUES (1, 'Registered');";
		$qry[] = "INSERT INTO `tblUserStatus` VALUES (2, 'PayPal SignUp');";
		$qry[] = "INSERT INTO `tblUserStatus` VALUES (3, 'PayPal Cancelled');";
		$qry[] = "INSERT INTO `tblUserStatus` VALUES (4, 'PayPal Failed');";
		$qry[] = "INSERT INTO `tblUserStatus` VALUES (5, 'PayPal Paid');";
		$qry[] = "INSERT INTO `tblUserStatus` VALUES (6, 'PayPal End of Term');";

		$qry[] = "DROP TABLE IF EXISTS `tblUsers`;";
		$qry[] = "CREATE TABLE `tblUsers` (
		  `user_id` int(11) NOT NULL auto_increment,
		  `user_firstname` varchar(32) NOT NULL default '',
		  `user_lastname` varchar(32) NOT NULL default '',
		  `user_email` varchar(96) NOT NULL default '',
		  `user_password` varbinary(32) NOT NULL default '',
		  `user_telephone` varchar(32) NOT NULL default '',
		  `user_fax` varchar(32) default NULL,
		  `user_address` varchar(64) NOT NULL default '',
		  `user_address2` varchar(64) default NULL,
		  `user_city` varchar(32) NOT NULL default '',
		  `user_state` varchar(32) default NULL,
		  `user_country` varchar(2) NOT NULL default 'US',
		  `user_postcode` varchar(10) NOT NULL default '',
		  `user_created` int(11) default NULL,
		  `user_status` int(2) NOT NULL default '1',
		  PRIMARY KEY  (`user_id`),
		  UNIQUE KEY `IDX_UNIQUE_CUSTOMERS_EMAIL_ADDRESS` (`user_email`),
		  KEY `user_status` (`user_status`)
		);";

		foreach($qry as $q){
			$sql->Query($q);
			if($sql->err_no != 0){
				$this->err_no = $sql->err_no;
				$this->err_msg = $sql->err_msg;
				return ($this->err_no);
			}
		}
		return (0);
	}


}

?>