<?php

	require_once('../lib/config.php');
	require_once('Smarty.class.php');
	require_once('Error.class.php');
	require_once('Paginate.class.php');
	require_once('User.class.php');
	require_once('HtPasswd.class.php');
	require_once('TxnLog.class.php');
	require_once('Maillist.class.php');
	require_once('Functions.class.php');

	if (!isset($_REQUEST['action']))$_REQUEST['action']='list';

	// Number of rows to show in a loop
	$show = 20;

	switch ($_REQUEST['action']) {


		case 'delete':
			$user = new User($_REQUEST['user_id']);
			if(!isset($_POST['confirm'])){
				$smarty = new Smarty();
				$smarty->assign('user', $user);
				$smarty->display('user_delete.tpl');
				exit();
			}else{
				// Remove from User table
				$user->deleteUser();

				// Remove from .htpasswd file
				$ht = new HtPasswd(SITE_DOC_ROOT . '/members/.htpasswd');
				if($ht->isUser($user->user_email)){
					$ht->deleteUser($user->user_email);
				}

				// Remove transactions in TxnLog table
				$txn = new TxnLog();
				$txn->user_id = $user->user_id;
				$txn->deleteUserLog();
				if($txn->err_no != 0){
					Error::errorMsg($txn->err_msg);
				}
			}
			header('Location: index.php');
		break;


		case 'update':

			$err = 0;

			// Clean up the passwords
			$_POST['user_password']              = trim($_POST['user_password']);
			$_POST['user_password_confirmation'] = trim($_POST['user_password_confirmation']);

			// Grant access
			if($_POST['submit']=='Grant Access'){
				$user = new User($_POST['user_id']);
				$ht=new HtPasswd(SITE_DOC_ROOT . '/members/.htpasswd');
				$ht->addUser($user->user_email, $user->user_password);
				header('Location: index.php?action=view&id=' . $_POST['user_id']);
			}


			// Revoke Access
			if($_POST['submit']=='Revoke Access'){
				$user = new User($_POST['user_id']);
				$ht=new HtPasswd(SITE_DOC_ROOT . '/members/.htpasswd');
				$ht->deleteUser($user->user_email);
				header('Location: index.php?action=view&id=' . $_POST['user_id']);
			}


			// Save
			if($_POST['submit']=='Save'){

				$user = new User($_POST['user_id']);

				if($_POST['user_password'] != ''){
					$user->user_password = $_POST['user_password'];
				}

				$user->user_firstname        = $_POST['user_firstname'];
				$user->user_lastname         = $_POST['user_lastname'];
				$user->user_email            = $_POST['user_email'];
				$user->user_telephone        = $_POST['user_telephone'];
				$user->user_fax              = $_POST['user_fax'];
				$user->user_address          = $_POST['user_address'];
				$user->user_address2         = $_POST['user_address2'];
				$user->user_city             = $_POST['user_city'];
				$user->user_state            = $_POST['user_state'];
				$user->user_country          = $_POST['user_country'];
				$user->user_postcode         = $_POST['user_postcode'];
				$user->user_status			 = $_POST['user_status'];

				$user->updateUser();
				if($user->err_no != 0){
					Error::errorMsg($user->err_msg);
					exit();
				}
			}
			header('Location: index.php');
		break;


		case 'view':
			$smarty = new Smarty();
			$pw = new HtPasswd('../members/.htpasswd');
			$user = new User($_REQUEST['id']);
			if(isset($_REQUEST['msg'])){
				$smarty->assign('msg', $_REQUEST['msg']);
			} else {
				$smarty->assign('msg', '');
			}
			$smarty->assign('user', $user);
			$smarty->assign('has_access', $pw->isUser($user->user_email));
			$smarty->assign('states', Forms::statesArray());
			$smarty->assign('countries', Forms::countriesArray());
			$smarty->assign('status', Forms::statusArray());
			$smarty->display('user_detail.tpl');
		break;


		case 'search':
			if(!isset($_REQUEST['P']))$_REQUEST['P']=1;
			if(!isset($_REQUEST['order']))$_REQUEST['order']='user_lastname';
			if(!isset($_REQUEST['dir']))$_REQUEST['dir']='ASC';
			$key = addslashes($_REQUEST['key']);
			$user = new User();
			$start = ($_REQUEST['P'] - 1) * $show;
			$results = $user->searchUsers($key, $start, $show, $_REQUEST['order'], $_REQUEST['dir']);
			$page = new Paginate();
			$page->total_count = $user->total_count;
			$page->cur_page = $_REQUEST['P'];
			$page->url = SITE_URL_ROOT . '/manager/index.php';
			$page->per_page = $show;
			$page->qry_str = 'action=search&amp;key=' . $key . '&amp;order=' . $_REQUEST['order'] . '&amp;dir=' . $_REQUEST['dir'];
			$smarty = new Smarty();
			$smarty->assign('users', $results);
			$smarty->assign('status', Forms::statusArray());
			$smarty->assign('key', $_REQUEST['key']);
			$smarty->assign('paginate', $page->ShowLinks());
			$smarty->display('user_list.tpl');
		break;


		case 'history':
			if(!isset($_REQUEST['user_id'])){
				Error::errorMsg('Unable to determine user id');
			}
			if(!isset($_REQUEST['P']))$_REQUEST['P']=1;
			if(!isset($_REQUEST['order']))$_REQUEST['order']='txn_date';
			if(!isset($_REQUEST['dir']))$_REQUEST['dir']='DESC';
			$log = new TxnLog();
			$page = new Paginate();
			$page->total_count = TxnLog::totalUserLog($_REQUEST['user_id']);
			$page->cur_page = $_REQUEST['P'];
			$page->url = SITE_URL_ROOT . '/manager/index.php';
			$page->qry_str = 'user_id=' . $_REQUEST['user_id'] . '&order=' . $_REQUEST['order'] . '&amp;dir=' . $_REQUEST['dir'];
			$page->per_page = $show;
			$smarty = new Smarty();
			$smarty->assign('user_id', $_REQUEST['user_id']);
			$start = ($_REQUEST['P'] - 1) * $show;
			$smarty->assign('logs', $log->userLog($_REQUEST['user_id'], $start, $show, $_REQUEST['order'], $_REQUEST['dir']));
			$smarty->assign('total_entries', $page->total_count);
			$smarty->assign('paginate', $page->ShowLinks());
			$smarty->display('user_log.tpl');
		break;


		case 'maillist':
			if(!isset($_POST['status']))$_POST['status']=array();
			if(!isset($_POST['email_only']))$_POST['email_only']=0;
			switch ($_POST['format']){
				case 'newline':
					$delimeter = "\n";
				break;
				case 'custom':
					$delimeter  = $_POST['custom'];
				break;
				case 'comma':
				default:
					$delimeter = ', ';
				break;
			}
			$list = new Maillist();
			$list->status = $_POST['status'];
			$users = $list->createList();
			$smarty = new Smarty();
			$smarty->assign('users', $users);
			$smarty->assign('email_only', $_POST['email_only']);
			$smarty->assign('delimeter', $delimeter);
			$smarty->assign('returned', $list->returned);
			$smarty->display('mail_list.tpl');
		break;


		case 'mailoptions':
			$smarty = new Smarty();
			$smarty->assign('status', Forms::statusArray());
			$smarty->display('mail_options.tpl');
		break;


		case 'adminpw':
			$smarty = new Smarty();
			$smarty->display('admin_pw.tpl');
		break;


		case 'changepw':

			$_REQUEST['old_password'] = trim($_REQUEST['old_password']);
			$_REQUEST['new_password'] = trim($_REQUEST['new_password']);
			$_REQUEST['confirm_password'] = trim($_REQUEST['confirm_password']);

			if(strlen($_REQUEST['new_password']) < 4){
				Error::errorMsg('Password must be at least 4 chars long.');
			}

			if($_REQUEST['new_password'] != $_REQUEST['confirm_password']){
				Error::errorMsg('Passwords do not match.');
			}

			$ht = new HtPasswd('.htpasswd');
			if(!$ht->checkPass('admin', $_REQUEST['old_password'])){
				Error::errorMsg('Incorrect Old Password');
			} else {
				$ht->changePass('admin', $_REQUEST['new_password']);
			}
			Functions::redirectMsg('Password Updated', 'index.php');
		break;

		case 'list':
		default:
			if(!isset($_REQUEST['P']))$_REQUEST['P']=1;
			if(!isset($_REQUEST['order']))$_REQUEST['order']='user_lastname';
			if(!isset($_REQUEST['dir']))$_REQUEST['dir']='ASC';
			$page = new Paginate();
			$page->total_count = User::totalUsers();
			$page->cur_page = $_REQUEST['P'];
			$page->url = SITE_URL_ROOT . '/manager/index.php';
			$page->qry_str = 'order=' . $_REQUEST['order'] . '&amp;dir=' . $_REQUEST['dir'];
			$page->per_page = $show;
			$smarty = new Smarty();
			$start = ($_REQUEST['P'] - 1) * $show;
			$smarty->assign('users', User::listUsers($start, $show, $_REQUEST['order'], $_REQUEST['dir']));
			$smarty->assign('total_users', $page->total_count);
			$smarty->assign('status', Forms::statusArray());
			$smarty->assign('paginate', $page->ShowLinks());
			$smarty->display('user_list.tpl');
		break;


	}

?>